//---------------------------------------------------------------------------
//
//  Module: dosapp.c
//
//  Purpose:
//     Interfaces to DOSXFER.386 to demonstrate Suspend/Resume.
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              6/ 5/93   BryanW      Wrote it.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

#include "dosapp.h"

//------------------------------------------------------------------------
//  void main( void )
//
//  Description:
//     Main routine.
//
//  Parameters:
//     Nothing.
//
//  History:   Date       Author      Comment
//              6/ 5/93   BryanW      Wrote it.
//
//------------------------------------------------------------------------

void main( void )
{
   unsigned long  dwVxDEntry ;

   _asm
   {
      mov   ax, 1684h
      mov   bx, DOSXFER_Device_ID
      int   2fh
      mov   word ptr dwVxDEntry, di
      mov   word ptr dwVxDEntry + 2, es
      int   3
   }
   if (dwVxDEntry == 0)
   {
      printf( "Error: DOSXFER Not Found!!!" ) ;
      exit ( -1 ) ;
   }

   while ( !kbhit() )
   {
      _asm
      {
         mov   dx, DOSXFER_Post_Message
         call  dword ptr [dwVxDEntry]
      }
   }
   exit ( 1 ) ;

} // end of main()

//---------------------------------------------------------------------------
//  End of File: dosapp.c
//---------------------------------------------------------------------------

