        page    60, 132

;******************************************************************************
	title	VDDVGA - VDD service table thunks for 'C'
;******************************************************************************
;
;   (C) Copyright Woodruff Software Systems, 1993
;
;   Title:    VDDVGA - VDD service table thunks for 'C'
;
;   Module:   SVCTHUNK.ASM
;
;   Version:  1.00
;
;   Date:     April 11, 1993
;
;   Author:   Bryan A. Woodruff
;
;******************************************************************************
;
;   Change log:
;
;   DATE      REVISION  DESCRIPTION                                 AUTHOR
;   --------  --------	------------------------------------------  -----------
;    4/11/93  1.00      Wrote it.                                   BryanW
;
;******************************************************************************
;
;   Functional Description:
;
;      Declares the VDD_Service_Table thunks for associated 'C' routines.
;
;******************************************************************************

        .386p

;==============================================================================
;                     I N C L U D E S   &   E Q U A T E S
;==============================================================================

.xlist
	INCLUDE VMM.INC

	INCLUDE VDD.INC
	INCLUDE DEBUG.INC

.list

;==============================================================================
;                                M A C R O S
;==============================================================================

Service_Thunk   MACRO   Service_Name, Type

IFNB <Type>
   IFIDNI <Type>, <ASYNC_SERVICE>
      BeginProc Service_Name, ASYNC_SERVICE
   ELSE
      %OUT ERROR: Service_Thunk <Type> parameter must be ASYNC_SERVICE or undefined
      .err
   ENDIF
ELSE
   BeginProc Service_Name, SERVICE
ENDIF
        EXTRN   _&Service_Name:NEAR

IFDEF DEBUG
        Debug_Out 'In &Service_Name'
ENDIF
        pushad
        pushfd
        push    esp
        cCall   _&Service_Name
        add     esp, 4
        popfd
        popad
        ret

   EndProc Service_Name

        ENDM

;==============================================================================
;                       P A G E A B L E   C O D E
;==============================================================================

VXD_CODE_SEG

Service_Thunk   VDD_Get_Version
Service_Thunk   VDD_PIF_State
Service_Thunk   VDD_Get_GrabRtn
Service_Thunk   VDD_Hide_Cursor
Service_Thunk   VDD_Set_VMType		
Service_Thunk   VDD_Get_ModTime 	
Service_Thunk   VDD_Set_HCurTrk 	
Service_Thunk   VDD_Msg_ClrScrn 	
Service_Thunk   VDD_Msg_ForColor	
Service_Thunk   VDD_Msg_BakColor	
Service_Thunk   VDD_Msg_TextOut 	
Service_Thunk   VDD_Msg_SetCursPos	
Service_Thunk   VDD_Query_Access	

;
; New services for 3.1
;
 
Service_Thunk   VDD_Check_Update_Soon

VXD_CODE_ENDS

end
