//---------------------------------------------------------------------------
//
//  Module: vddphmem.h
//
//  Purpose:
//     header file for vddphmem.c
//
//     Based on original Windows 3.1 VDD sources as supplied by
//     the Microsoft Windows 3.1 Device Driver Development Kit.
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              4/10/93   BryanW      Converted to 'C'.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

typedef struct tagPHYSPAGEDATA
{
   DWORD  PPD_LRU_time ;   // sys time of last access
   DWORD  PPD_owner_PH ;   // page handle of virtual owner

} PHYSPAGEDATA, *PPHYSPAGEDATA ;

#define PPD_Index_Factor  3

#define PPD_Index_to_Ptr( x ) ((x << PPD_Index_Factor) + dwVidPageTable)
#define PPD_Ptr_to_Index( x ) ((x - dwVidPageTable) >> PPD_Index_Factor)

//
// A page handle is a ptr to a Page_Data_Struc block
//

typedef struct tagPAGEDATA
{
   WORD   PDS_physpage ;     // index into table of physical pages
   BYTE   PDS_resvd ;
   BYTE   PDS_flags ;
   WORD   PDS_virtual_id ;   // virtual page ID
   WORD   PDS_linear_page ;  // set & used by VDDVMEM routines
   DWORD  PDS_owner ;        // owner VM handle
   DWORD  PDS_callback ;     // handler callback proc address

} PAGEDATA, *PPAGEDATA ;

#define Next_Planar_Page_Id   1

#ifdef DEBUG
#define PD_Debug_Mask   0x000F  // bottom 4 bits must be clear in a
#endif

#define fPDS_Saved      0x0001
#define fPDS_Dirty      0x0040

//---------------------------------------------------------------------------
//  End of File: vddphmem.h
//---------------------------------------------------------------------------
