//---------------------------------------------------------------------------
//
//  Module: shell.h
//
//  Purpose:
//     Shell VxD interface definitions.
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              4/25/93   BryanW      Wrote it.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

//
// Windows Message Box Flags used on SHELL_SYSMODAL_Message and
// SHELL_Message services
//

#define MB_OK                  0x0000
#define MB_OKCANCEL            0x0001
#define MB_ABORTRETRYIGNORE    0x0002
#define MB_YESNOCANCEL         0x0003
#define MB_YESNO               0x0004
#define MB_RETRYCANCEL         0x0005
#define MB_ICONHAND            0x0010
#define MB_ICONEXCLAMATION     0x0030
#define MB_ICONASTERISK        0x0040
#define MB_DEFBUTTON1          0x0000
#define MB_DEFBUTTON2          0x0100
#define MB_DEFBUTTON3          0x0200
#define MB_APPLMODAL           0x0000
#define MB_SYSTEMMODAL         0x1000
#define MB_NOFOCUS             0x8000

//
// Following bits are WIN386 SHELL extensions
// 

#define MB_ASAP                0x80000000   // Message is timely, put
                                            // up as soon as possible.

//
// The following flag bits are 3.10 extensions.
//

#define MB_NOWINDOW            0x40000000   // DO NOT switch to Windows
                                            // to do this message, do it
                                            // in full screen mode always.
                                            // ONLY FOR SHELL_SYSMODAL_Message

#define MB_HANGSYS             0x20000000   // Hang with ints disabled.
                                            // This is for especially
                                            // severe errors (like parity
                                            // errors).
                                            // ONLY FOR SHELL_SYSMODAL_Message

//
// Windows Message Box Return codes used on SHELL_SYSMODAL_Message and
// SHELL_Message services
//

#define IDOK                   1
#define IDCANCEL               2
#define IDABORT                3
#define IDRETRY                4
#define IDIGNORE               5
#define IDYES                  6
#define IDNO                   7

//---------------------------------------------------------------------------
//  End of File: shell.h
//---------------------------------------------------------------------------

