//---------------------------------------------------------------------------
//
//  Module: vsimpled.c
//
//  Purpose:
//     A simple VxD written in 'C'.
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              3/ 9/93   BryanW      Wrote it.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

#include <vmm.h>
#include "vsimpled.h"

#pragma data_seg( "_LDATA", "CODE" )

//=============================================================================
//          V I R T U A L   D E V I C E   D E C L A R A T I O N
//=============================================================================

DDB VSIMPLED_DDB = { NULL,                      // reserved, must be NULL
                     DDK_Version,               // reserved, DDK_Version
                     VSIMPLED_Device_ID,        // Device ID
                     VSIMPLED_Major_Ver,        // Major Version
                     VSIMPLED_Minor_Ver,        // Minor Version
                     NULL,
                     "VSIMPLED",
                     Undefined_Init_Order,
                     (DWORD) vmmwrapVxDControlProc,
                     NULL,
                     NULL,
                     NULL,
                     NULL,
                     NULL,
                     NULL,
                     NULL } ;

//
// This table is used by the vmmwrapVxDControlProc defined in VMMWRAP.ASM.                  
// It lists the messages and associated dispatch functions, it
// must be terminated with -1 and NULL.                  
//

DISPATCHINFO alpVxDDispatchProcs[] =
   { Sys_Critical_Init,   VSIMPLED_Sys_Critical_Init,
     Device_Init,         VSIMPLED_Device_Init,
     Create_VM,           VSIMPLED_Create_VM,
     -1,                  NULL } ;

//------------------------------------------------------------------------
//  BOOL CDECL VSIMPLED_Create_VM( DWORD hVM, PCRS_32 pCRS )
//
//  Description:
//     Notification of when VMs (other than system VM) are created.
//
//  Parameters:
//     hVM
//        VM handle
//
//     pCRS
//        pointer to client register structure
//
//  History:   Date       Author      Comment
//              3/ 9/93   BryanW      Wrote it.
//
//------------------------------------------------------------------------

BOOL CDECL VSIMPLED_Create_VM( DWORD hVM, PCRS_32 pCRS )
{
   UNUSED_PARAM( hVM ) ;
   UNUSED_PARAM( pCRS ) ;

   vmmTraceOut( "VSIMPLED_Create_VM\r\n" ) ;

   return ( TRUE ) ;
   
} // end of VSIMPLED_Create_VM()

//---------------------------------------------------------------------------
//  End of File: vsimpled.c
//---------------------------------------------------------------------------

