	.386p

	include	vmm.inc
	include	shell.inc
	include	debug.inc
	include	v86mmgr.inc
	include	win_ipc.inc

Declare_Virtual_Device DAVE, 1, 0, WinIpc_Control, WIN_IPC_ID, VPD_Init_Order+1, WinIpc_V86_API_Proc, WinIpc_PM_API_Proc


VxD_DATA_SEG

CbVmData	dd	0
SysVm		dd	0
SysCallBack	dd	0
SysWnd		dw	0
SysFlags	dw	TITLE_OFF or EXEC_OFF or PRINT_OFF or MEM_OFF or IPC_OFF
SysTimeOut	dw	45 * 100

MsgDispTable	label	dword
	dd	offset32	MsgGetVer
	dd	offset32	MsgRegister
	dd	offset32	MsgUnregister
	dd	offset32	MsgQueryVm
	dd	offset32	MsgLaunch
	dd	offset32	MsgPost
	dd	offset32	MsgPeek
	dd	offset32	MsgRead
	dd	offset32	MsgPrnOpen
	dd	offset32	MsgPrnWrite
	dd	offset32	MsgPrnClose
	dd	offset32	MsgMemCopy
	dd	offset32	MsgMemLdt
	dd	offset32	MsgMemFreeLdt
	dd	offset32	MsgMemGdt
	dd	offset32	MsgMemFreeGdt
	dd	offset32	MsgSetTitle

	dd	offset32	_MsgRegister
	dd	offset32	_MsgUnregister
	dd	offset32	_MsgSendRtn
	dd	offset32	_MsgSetWinFile
	dd	offset32	_MsgSetFlags
	dd	offset32	_MsgPrnBlkRtn
	dd	offset32	_MsgSetIgnoreWin
	dd	offset32	_MsgSetTimeOut
	dd	offset32	_MsgShellEvent
NumMsgDisp	EQU	($ - MsgDispTable) / 4

PmOkTable	label	byte
	db	-1
	db	0
	db	0
	db	-1
	db	-1
	db	-1
	db	0
	db	0
	db	0
	db	0
	db	0
	db	-1
	db	-1
	db	-1
	db	-1
	db	-1
NumPmOk	EQU	$ - PmOkTable

VmMsgArr	VmMsg NUM_MSG_STRUC dup (<?>)

VmMsgOff	dd	OFFSET32 VmMsgArr
VmMsgAlloc	dw	NUM_MSG_STRUC
VmMsgNum	dw	0

SysFile		db	"WIN.COM"
		db	9 dup (0)
SysFileLen	dw	8
IgnoreStr	db	10,13,"Windows already running - Press CTRL ESC for Task Manager",10,13,'$'
IgnoreLen	EQU	$ - IgnoreStr
		db	(160 - IgnoreLen) + 4 dup ('$')

VxD_DATA_ENDS


VxD_ICODE_SEG

BeginProc WinIpc_Sys_Critical_Init

	VMMCall	_Allocate_Device_CB_Area, <<size VmData>, 0>
	cmp	eax, 0
	je	short sci10
	mov	[CbVmData], eax
	and	[SysFlags], not MEM_OFF

	mov	eax, ebx
	call	GetVmData
	mov	[esi.VmHandle], ebx

	VMMcall	Get_Sys_VM_Handle		; Save System VM
	mov	[SysVm], ebx

sci10:	clc
	ret

EndProc WinIpc_Sys_Critical_Init

BeginProc WinIpc_Dev_Init

	mov	eax, 17h			; Sit on int 17
	mov	esi, OFFSET32 WinIpc_Int_17
	VMMcall Hook_V86_Int_Chain

	mov	eax, 21h			; Sit on int 21
	mov	esi, OFFSET32 WinIpc_Int_21
	VMMcall Hook_V86_Int_Chain

	mov	eax, 23h			; Sit on int 23
	mov	esi, OFFSET32 WinIpc_Int_23
	VMMcall Hook_V86_Int_Chain

	mov	eax, 24h			; Sit on int 24
	mov	esi, OFFSET32 WinIpc_Int_24
	VMMcall Hook_V86_Int_Chain

	mov	eax, 2Fh			; Sit on int 2F
	mov	esi, OFFSET32 WinIpc_Int_2F
	VMMcall Hook_V86_Int_Chain

	clc
	ret

EndProc WinIpc_Dev_Init

VxD_ICODE_ENDS


VxD_LOCKED_CODE_SEG

BeginProc WinIpc_Control

	Control_Dispatch VM_Init,		WinIpc_VM_Create
	Control_Dispatch VM_Not_Executeable,	WinIpc_VM_Terminate
	Control_Dispatch Sys_Critical_Init,	WinIpc_Sys_Critical_Init
	Control_Dispatch Device_Init,		WinIpc_Dev_Init
	clc
	ret

EndProc WinIpc_Control

BeginProc WinIpc_VM_Create

	test	[SysFlags], MEM_OFF
	jnz	vmc10

	; Get & zero-fill VmData
	mov	eax, ebx
	call	GetVmData
	mov	edi, esi
	xor	eax, eax
	mov	ecx, (size VmData) / 4
	rep	stosd

	; Init VmData
	mov	[esi.VmHandle], ebx
	lea	ecx, [esi].MsgArr
	mov	[esi].MsgGet, ecx
	mov	[esi].MsgPut, ecx
	mov	eax, MAX_DOS_MSG - 1
	mov	edx, size DosMsg
	mul	edx
	add	eax, ecx
	mov	[esi].MsgLast, eax

	; Get the PSP (via SDA) location
	Push_Client_State
	VMMcall	Begin_Nest_Exec

	mov	[ebp.Client_AX], 5D06h
	mov	eax, 21h
	VMMcall	Exec_Int
	movzx	edx, [ebp.Client_DS]
	shl	edx, 4
	movzx	eax, [ebp.Client_SI]
	add	edx, eax
	add	edx, [ebx.CB_High_Linear]
	add	edx, 10h
	mov	[esi].pPsp, edx

	VMMcall	End_Nest_Exec
	Pop_Client_State

	xor	ecx, ecx			; Set up Msg semaphore
	VMMcall	Create_Semaphore
	jc	vmc10
	mov	[esi].MsgSem, eax

	xor	ecx, ecx			; Set up Prn semaphore
	VMMcall	Create_Semaphore
	jc	vmc10
	mov	[esi].PrnSem, eax

					SizeVmData EQU (size VmData)
	VMMcall	_BuildDescriptorDWORDs	<esi, SizeVmData, RW_Data_Type, D_GRAN_BYTE, 0>
	VMMcall	_Allocate_LDT_Selector	<[SysVm], edx, eax, 1, 0>
	rol	eax, 16
	mov	[esi.VmLdt], eax

	; Build linked-list
	; Do this last so we are only in the list if 1) We are all
	; filled in & 2) We were able to set up semaphores, etc.
	mov	edi, esi
	mov	eax, [SysVm]
	call	GetVmData
	mov	eax, [esi.LinkNext]
	mov	[edi.LinkNext], eax
	mov	[esi.LinkNext], edi

	mov	eax, [esi.LdtNext]
	mov	[edi.LdtNext], eax
	mov	eax, [edi.VmLdt]
	mov	[esi.LdtNext], eax

	; We now send a msg to set the title.  We do this here
	; so it gets it BEFORE another VM is created since we
	; just grab the first free VM in Windows.
	PostPm	[SysVm], [SysWnd], MSG_DOS_TITLE, 0, [edi.VmLdt]

vmc10:	clc
	ret

EndProc WinIpc_VM_Create

BeginProc WinIpc_VM_Terminate

	test	[SysFlags], MEM_OFF
	jnz	short vmt10

	mov	eax, ebx
	call	GetVmData
	
	cmp	ebx, [SysVm]			; If WinApp - turn off IPC
	jne	short vmt10
	or	[SysFlags], IPC_OFF
	mov	[SysVm], 0
	mov	[SysWnd], 0
	clc
	ret

vmt10:	; Kill printing (if any)
	xor	cx, cx
	xchg	[esi.hDc], cx
	cmp	cx, 0
	je	short vmt20
	movzx	edx, [esi.iStr]
	push	esi
	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR_DESTROY, cx, edx
	pop	esi

vmt20:	; take us out of the linked list
	mov	edi, esi
	mov	eax, [SysVm]

	call	GetVmData
vmt30:	cmp	[esi.LinkNext], edi
	je	short vmt40
	cmp	[esi.LinkNext], 0
	je	short vmt50
	mov	esi, [esi.LinkNext]
	jmp	short vmt30

vmt40:	mov	eax, [edi.LinkNext]
	mov	[esi.LinkNext], eax
	mov	eax, [edi.LdtNext]
	mov	[esi.LdtNext], eax

vmt50:	mov	eax, 0
	xchg	eax, [esi.VmLdt]
	rol	eax, 16
	or	eax, eax
	jz	short vmt60
	VMMcall	_Free_LDT_Selector	<[SysVm], eax, 0>

vmt60:	clc
	ret

EndProc WinIpc_VM_Terminate

; The critical section is now not owned.  We now need to
; call the DOS box so we can do a wait semaphore.
PrnCallDelay	proc

	xor	eax, eax
	mov	ebx, edx
	mov	ecx, PEF_Wait_Not_Crit
	mov	esi, offset32 PrnDelay

	VMMcall	Call_Priority_VM_Event

	ret

PrnCallDelay	endp

PrnDelay	proc

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	mov	eax, edx
	call	GetVmData

	mov	eax, [esi.PrnSem]
	mov	ecx, Block_Svc_Ints
	VMMcall	Wait_Semaphore			; We're locked

	xor	ax, ax
	xchg	[esi.iPrnErr], ax
	cmp	ax, 0
	je	short pd20
	movzx	ecx, [esi].PrntNum
	lea	esi, [esi].PrntBuf

pd10:	; check status - exit if error
	mov	eax, 200h
	xor	edx, edx
	VxDint	17h
	test	ah, 6Fh
	jnz	short pd20
	test	ah, 10h
	jz	short pd20

	xor	eax, eax
	xor	edx, edx
	lodsb
	VxDint	17h
	loop	pd10

pd20:	VMMcall	End_Nest_Exec
	Pop_Client_State

pd30:	ret

PrnDelay	endp

PrnTime	proc

	mov	[edx.TimeHdl], 0
	mov	[edx.sPsp], 0

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	mov	esi, edx
	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR_DNE, [esi.PrntNum], [esi.VmLdt]

	VMMcall	End_Nest_Exec
	Pop_Client_State
	ret

PrnTime	endp

BeginProc WinIpc_Int_17

	test	[SysFlags], IPC_OFF or MEM_OFF or PRINT_OFF
	jnz	i17_60				; We're off
	cmp	[SysVm], ebx			; system VM?
	je	i17_60

	cmp	[ebp.Client_AH], 2
	ja	i17_60

	cmp	[ebp.Client_DX], 0
	jne	i17_60

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	mov	eax, ebx
	call	GetVmData

	; if status - return OK (90h) if room in buffer
	cmp	[ebp.Client_AH], 0
	je	short i17_10

	mov	ch, PRN_OK			; OK
	cmp	[esi.PrntNum], SIZE_PRNT_BUF
	jb	i17_50
	mov	ch, PRN_BUSY			; BUSY
	jmp	i17_50

i17_10:	cmp	[esi.sPsp], 0
	jne	i17_30

	; if we have no PSP AND do have a DC - we return BUSY - we're
	; ending a job
	mov	ch, PRN_BUSY
	cmp	[esi.hDc], 0
	jne	i17_50

	; Get the PSP - get the app name - copy it to esi.sPsp
	call	GetPsp
	jc	short i17_17
	mov	eax, dword ptr [edi]
	mov	dword ptr [esi.sPsp], eax
	mov	eax, dword ptr [edi+4]
	mov	dword ptr [esi.sPsp+4], eax
	mov	byte ptr [esi.sPsp+8], 0

	cmp	[esi.sPsp], 0
	jne	short i17_20
i17_17:	mov	dword ptr [esi.sPsp], 6E6B6E55h
	mov	dword ptr [esi.sPsp+4], 006E776Fh

i17_20:	mov	edx, [esi.VmLdt]
	lea	eax, [esi].sPsp

	; print the char
	lea	edi, [esi]+PrntBuf
	mov	[esi.PrntNum], 1
	mov	al, [ebp.Client_AL]
	mov	[edi], al

	; Send Create Message
	push	[ebp.Client_EAX]
	push	ebx
	PostPm	[SysVm], [SysWnd], MSG_PRINT_PSP, 0, edx
	pop	ebx
	pop	[ebp.Client_EAX]

	; I've told it to start.  Now I need to generate a call-back
	; to this VM when its no longer in a critical section
	mov	esi, offset32 PrnCallDelay
	mov	edx, ebx
	VMMcall	Call_When_Not_Critical

	mov	ch, PRN_OK			; OK
	jmp	i17_50

i17_30:	; kill old timer
	xor	eax, eax
	xchg	eax, [esi.TimeHdl]
	xchg	eax, esi
	VMMcall	Cancel_time_out
	mov	esi, eax

	; if we are past the end of the buffer - return BUSY!!!
	mov	ch, PRN_BUSY			; BUSY
	cmp	[esi.PrntNum], SIZE_PRNT_BUF
	jae	short i17_40			; FULL - return BUSY

	lea	edi, [esi]+PrntBuf		; Not FULL
	inc	[esi.PrntNum]
	movzx	eax, [esi.PrntNum]
	mov	cl, [ebp.Client_AL]
	mov	[edi+eax-1], cl
	mov	ch, PRN_OK			; OK
	cmp	eax, SIZE_PRNT_BLOCK
	jne	short i17_40			; Still not full

	; FULL - send the block
	push	esi
	push	ebx
	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR, [esi.PrntNum], [esi.VmLdt]
	pop	ebx

	; I've told it to print.  Now I need to generate a call-back
	; to this VM when its no longer in a critical section
	mov	edx, ebx
	mov	esi, offset32 PrnCallDelay
	VMMcall	Call_When_Not_Critical

	pop	esi
	mov	ch, PRN_OK			; OK

	; set new timer
i17_40:	push	ecx
	movzx	eax, SysTimeOut
	mov	edx, esi
	mov	esi, offset32 PrnTime
	VMMcall	Set_VM_Time_Out
	mov	[edx.TimeHdl], esi
	pop	ecx

i17_50:	VMMcall	End_Nest_Exec
	Pop_Client_State
	mov	[ebp.Client_AH], ch

	clc
	ret

i17_60:	stc					; return continue chain
	ret

EndProc WinIpc_Int_17

DiStk struc
	RwBuf	dd	?
	hVm	dd	?
	pFn	dd	?
	pCmd	dd	?
	OffI24	dd	?
	SegI24	dd	?
	hFile	dw	?
	zFill	dw	?
DiStk	ends
.errnz	((size DiStk) and 3)

BeginProc WinIpc_Int_21

	test	[SysFlags], IPC_OFF or MEM_OFF
	jnz	i21_160
	cmp	[SysVm], ebx			; system VM?
	je	i21_160

	cmp	[ebp.Client_AH], 5Dh		; PRINT stuff?
	jne	i21_30
	test	[SysFlags], PRINT_OFF		; PRINT off?
	jnz	i21_20

	cmp	[ebp.Client_AL], 09		; redir?
	je	short i21_10			; YES
	cmp	[ebp.Client_AL], 08		; redir?
	jne	i21_20				; NO
	cmp	[ebp.Client_DL], 0		; combined (no break)?
	je	i21_20				; YES - skip

i21_10:	mov	eax, ebx
	call	GetVmData
	cmp	[esi.sPsp], 0
	je	short i21_20
	
	Push_Client_State
	VMMcall	Begin_Nest_Exec

	; Kill the timer
	xor	eax, eax
	xchg	eax, [esi.TimeHdl]
	xchg	eax, esi
	VMMcall	Cancel_time_out
	mov	esi, eax

	mov	[esi.sPsp], 0
	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR_DNE, [esi.PrntNum], [esi.VmLdt]

	VMMcall	End_Nest_Exec
	Pop_Client_State

i21_20:	stc
	ret

	; If on our last Int 21 we did an exec/terminate - we
	; now need to set the window title
i21_30:	test	[SysFlags], TITLE_OFF		; TITLE off?
	jnz	i21_70

	; Do we need to set the title?
	mov	eax, ebx
	call	GetVmData
	test	[esi.wFlags], TITLE_SET
	jz	i21_50
	

	; Get the PSP - get the app name - copy it to esi.sPsp
	mov	eax, ebx
	call	GetVmData
	call	GetPsp
	jc	short i21_50

	mov	eax, dword ptr [edi]
	mov	dword ptr [esi.sTitle], eax
	mov	eax, dword ptr [edi+4]
	mov	dword ptr [esi.sTitle+4], eax
	mov	byte ptr [esi.sTitle+8], 0
	and	[esi.wFlags], not TITLE_SET	; Turn it off

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	PostPm	[SysVm], [SysWnd], MSG_DOS_TITLE, 0, [esi.VmLdt]

	VMMcall	End_Nest_Exec
	Pop_Client_State

i21_50:	test	[SysFlags], TITLE_OFF		; TITLE off?
	jnz	short i21_70

;	cmp	[ebp.Client_AH], 50h		; Set PSP
;	je	short i21_60
	cmp	[ebp.Client_AH], 4Ch		; new terminate?
	je	short i21_60
	cmp	[ebp.Client_AH], 4Bh		; EXEC
	je	short i21_60
	cmp	[ebp.Client_AH], 31h		; TSR terminate?
	je	short i21_60
	cmp	[ebp.Client_AH], 00h		; old terminate?
	jne	short i21_70

i21_60:	mov	eax, ebx
	call	GetVmData
	or	[esi.wFlags], TITLE_SET

i21_70:	cmp	[ebp.Client_AX], 4B00h		; EXEC, func 0?
	jne	i21_160

	test	[SysFlags], EXEC_OFF		; EXEC off?
	jnz	i21_160

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	push	edi				; local vars
	push	esi				; local vars
	sub	esp, size DiStk
	mov	edi, esp
	mov	[edi.hVm], ebx

	movzx	edx, [ebp.Client_ES]		; get offset to cmd line
	shl	edx, 4
	movzx	eax, [ebp.Client_BX]
	add	edx, eax
	add	edx, [ebx.CB_High_Linear]

	movzx	eax, word ptr [edx+4]
	shl	eax, 4
	movzx	edx, word ptr [edx+2]
	add	edx, eax
	add	edx, [ebx.CB_High_Linear]
	mov	[edi.pCmd], edx

	movzx	edx, [ebp.Client_DS]		; get offset to file name
	shl	edx, 4
	movzx	eax, [ebp.Client_DX]
	add	edx, eax
	add	edx, [ebx.CB_High_Linear]
	mov	[edi.pFn], edx

	; Cmp to SysFile - if win.com - send to windows
	push	edi
	mov	edi, edx			; get root file name
	mov	ecx, 128
	mov	al, 0
	repne	scasb				; at term 0
	dec	edi

i21_90:	dec	edi
	cmp	byte ptr [edi], '\'
	je	short i21_100
	cmp	byte ptr [edi], '/'
	je	short i21_100
	cmp	byte ptr [edi], ':'
	je	short i21_100
	cmp	edi, edx
	jb	short i21_100
	jmp	short i21_90

i21_100:	inc	edi				; see if they match
	mov	esi, offset32 [SysFile]
	movzx	ecx, [SysFileLen]
	repe	cmpsb
	pop	edi
	jz	i21_120				; match - go to DOS

	mov	eax, ebx
	call	GetVmData
	and	[esi.wFlags], not TITLE_SET	; OFF till done

	or	[esi.wFlags], I24_ON
	mov	eax, 3D20h			; open file
	VxDint	21h
	jnc	short i21_110			; NO error on open
	and	[esi.wFlags], not I24_ON
	cmp	al, 5				; file locked?
	jne	i21_150				; NO - leave it to DOS
	jmp	i21_120

i21_110:	and	[esi.wFlags], not I24_ON
	mov	[edi.hFile], ax
	mov	ebx, eax

	mov	eax, 3F00h			; read MZ
	mov	ecx, 2
	lea	edx, [edi]+RwBuf
	VxDint	21h
	jc	i21_140
	cmp	word ptr [edi.RwBuf], 5A4Dh
	jne	i21_140

	mov	eax, 4200h			; seek to offset
	xor	ecx, ecx
	mov	edx, 3Ch
	VxDint	21h
	jc	i21_140

	mov	eax, 3F00h			; read offset
	mov	ecx, 4
	lea	edx, [edi]+RwBuf
	VxDint	21h
	jc	i21_140

	movzx	edx, word ptr [edi.RwBuf]	; Seek to new EXE
	movzx	ecx, word ptr [edi.RwBuf+2]
	mov	eax, 4200h
	VxDint	21h
	jc	i21_140

	mov	eax, 3F00h			; read NE
	mov	ecx, 2
	lea	edx, [edi]+RwBuf
	VxDint	21h
	jc	i21_140
	cmp	word ptr [edi.RwBuf], 454Eh
	jne	i21_140

	mov	bx, [edi.hFile]			; close file
	mov	eax, 3E00h
	VxDint	21h

i21_120:	mov	ebx, [edi.hVm]
	mov	eax, ebx
	call	GetVmData

	push	edi
	push	esi

	mov	edi, [edi].pFn
	lea	esi, [esi].sExec		; copy fn
	xchg	esi, edi
	mov	ecx, 128 / 4
	rep	movsd

	pop	esi
	pop	edi
	push	edi
	push	esi

	mov	edi, [edi].pCmd			; copy command line
	lea	esi, [esi].sCmdLine
	xchg	esi, edi
	mov	ecx, 128 / 4
	rep	movsd

	pop	esi
	pop	edi

	mov	edx, [esi.VmLdt]
	Save	<edi,esi>
	SendPm	[SysVm], [SysWnd], MSG_WIN_EXEC, 0, edx

	Restore	<esi,edi>
	mov	ebx, [edi.hVm]

	cmp	edx, 1				; Ignore?
	jne	short i21_130
	mov	edx, offset32 IgnoreStr
	mov	ah, 09h
	VxDint	21h
	mov	edx, 0

i21_130:	cmp	edx, 0				; WinExec OK?
	jne	short i21_150

	mov	eax, ebx
	call	GetVmData
	or	[esi.wFlags], TITLE_SET

	add	esp, size DiStk
	pop	esi
	pop	edi
	VMMcall	End_Nest_Exec
	Pop_Client_State

	clc					; return done
	ret

i21_140: mov	bx, [edi.hFile]			; close file
	mov	eax, 3E00h
	VxDint	21h

i21_150: mov	ebx, [edi.hVm]

	mov	eax, ebx
	call	GetVmData
	or	[esi.wFlags], TITLE_SET

	add	esp, size DiStk
	pop	esi
	pop	edi
	VMMcall	End_Nest_Exec
	Pop_Client_State

i21_160: stc					; return continue chain
	ret

EndProc WinIpc_Int_21

;entry:	esi=VmData
;	ebx=Vm
;exit:	edi=Psp-9
BeginProc GetPsp

	Assert_VM_Handle <ebx>
	Save	<eax,ecx,edx>

	mov	edi, [esi].pPsp
	mov	eax, edi
	shr	eax, 12
	mov	edx, 1
	mov	ecx, edi
	and	ecx, 0FFFh
	cmp	ecx, 0FFFh
	jne	short gp10
	inc	edx
gp10:	Save	<edx>
	VMMCall	_PageCheckLinRange, <eax, edx, 0>
	Restore	<edx>
	cmp	edx, eax
	jne	short gp40
	movzx	edi, word ptr [edi]

	cmp	di, 8				; bad or DOS?
	jbe	short gp40

	dec	edi				; MCB
	shl	edi, 4
	add	edi, [ebx.CB_High_Linear]
	mov	eax, edi
	shr	eax, 12
	mov	edx, 1
	mov	ecx, edi
	and	ecx, 0FFFh
	cmp	ecx, 0FF0h
	jb	short gp20
	inc	edx
gp20:	Save	<edx>
	VMMCall	_PageCheckLinRange, <eax, edx, 0>
	Restore	<edx>
	cmp	edx, eax
	jne	short gp40

	cmp	byte ptr [edi], 'M'
	je	short gp30
	cmp	byte ptr [edi], 'Z'
	jne	short gp40

gp30:	Restore	<edx,ecx,eax>
	add	edi, 8
	clc
	ret

gp40:	Restore	<edx,ecx,eax>
	stc
	ret

EndProc GetPsp

BeginProc WinIpc_Int_23

	mov	eax, ebx
	call	GetVmData

	or	[esi.wFlags], TITLE_SET

	stc
	ret

EndProc WinIpc_Int_23

BeginProc WinIpc_Int_24

	mov	eax, ebx
	call	GetVmData

	or	[esi.wFlags], TITLE_SET

	test	[esi.wFlags], I24_ON
	jz	short i24_10

	mov	[ebp.Client_AL], 3
	clc
	ret

i24_10:	stc
	ret

EndProc WinIpc_Int_24

BeginProc WinIpc_Int_2F

	cmp	[ebp.Client_AX], 0101h
	jne	i2f_20

	test	[SysFlags], PRINT_OFF		; PRINT off?
	jnz	i2f_20

	Push_Client_State
	VMMcall	Begin_Nest_Exec

	mov	eax, ebx
	call	GetVmData

	push	esi
	lea	edi, [esi]+sPrntStr
	movzx	eax, [ebp.Client_DS]		; get offset to file name
	shl	eax, 4
	movzx	edx, [ebp.Client_DX]
	add	eax, edx
	add	eax, [ebx.CB_High_Linear]
	movzx	edx, word ptr [eax+3]
	shl	edx, 4
	movzx	esi, word ptr [eax+1]
	add	esi, edx
	add	esi, [ebx.CB_High_Linear]
	mov	ecx, 128 / 4
	rep	movsd
	pop	esi

	mov	edx, [esi.VmLdt]
	SendPm	[SysVm], [SysWnd], MSG_PRINT_FILE, 0, edx

	cmp	edx, 0
	jne	short i2f_10

	VMMcall	End_Nest_Exec
	Pop_Client_State

	clc
	ret

i2f_10:	VMMcall	End_Nest_Exec
	Pop_Client_State

i2f_20:	stc					; return continue chain
	ret

EndProc WinIpc_Int_2F

BeginProc WinIpc_V86_API_Proc

	cmp	[ebp.Client_AX], MSG_DOS_MAX
	ja	short vap10

	call	DefMsgProc
	ret

vap10:	mov	[ebp.Client_AX], ERR_UNKNOWN_MSG
	ret					; exit error

EndProc WinIpc_V86_API_Proc

BeginProc WinIpc_PM_API_Proc

	movzx	eax, [ebp.Client_AX]
	cmp	eax, (NumPmOk - 1)
	ja	short pap10
	and	eax, 0FFh
	mov	al, [PmOkTable + eax]
	cmp	al, 0
	je	short pap20

pap10:	call	DefMsgProc
	ret

pap20:	mov	[ebp.Client_AX], ERR_UNKNOWN_MSG
	ret					; exit error

EndProc WinIpc_PM_API_Proc

HandleCallBack  proc

	Assert_VM_Handle <ebx>
	Push_Client_State

	mov	edi, edx			; Get pointer
	mov	eax, [edi.lParam1]		; Set up registers
	mov	[ebp.Client_EAX], eax
	mov	eax, [edi.lParam2]
	mov	[ebp.Client_EDX], eax
	mov	eax, [edi.lWndMsg]
	mov	[ebp.Client_ECX], eax
	mov	[ebp.Client_EBX], edi

	mov	edx, [SysCallBack]

	mov	cx, dx				; Call the sucker
	shr	edx, 16
	VMMcall	Begin_Nest_Exec
	VMMcall	Simulate_Far_Call
	VMMcall	Resume_Exec
	VMMcall	End_Nest_exec

	mov	eax, [ebp.Client_EAX]		; save rtn value
	mov	[edi.Rtn], eax

	cmp	ebx, [SysVm]			; SendMessage (Windows)?
	je	short hcb10

	test	[edi.lParam1], FLAG_SEND_MSG	; send?
	jz	short hcb10
	mov	eax, [edi.SendSem]
	VMMcall	Signal_Semaphore

hcb10:	test	[edi.lParam1], FLAG_SEND_MSG	; send?
	jnz	short hcb20
	mov	[edi.Handle], 0			; Mark VmMsg avail

hcb20:	Pop_Client_State
	ret

HandleCallBack  endp

; eax = VM
; rtn esi = VmData

GetVmData  proc

	Assert_VM_Handle <eax>
	mov	esi, eax			; get CB data
	add	esi, [CbVmData]
	ret

GetVmData  endp

; eAX	lParam1 / BX	wParam
; eCL	hWnd
; eCH	uMsg	
; eDX	lParam

DefMsgProc  proc

	test	[SysFlags], MEM_OFF			; Are we running?
	jz	short dmp20
	mov	[ebp.Client_AX], ERR_NO_VM_MEMORY
	ret

dmp20:	movzx	eax, [ebp.Client_AX]		; Get the message
	jmp	[MsgDispTable + 4 * eax]

DefMsgProc  endp

LinkMsgProc  proc

	; We have a message to post/send.
	; We can't send a msg from Windows to Windows!!

dmp40:	test	[SysFlags], IPC_OFF			; Are we running?
	jz	short dmp50
	mov	[ebp.Client_AX], ERR_NO_WIN_APP
	ret

dmp50:	cmp	ebx, [SysVm]			; Win Msg to WinMsg?
	jne	short dmp60
	cmp	ebx, [ebp.Client_EBX]
	jne	short dmp60
	mov	[ebp.Client_AX], ERR_WIN_TO_WIN
	ret

dmp60:	mov	eax, [ebp.Client_EBX]		; Get destination VM
	call	GetVm
	jc	short dmp65
	call	GetVmData

	cmp	[SysCallBack], 0
	jne	short dmp70
dmp65:	mov	[ebp.Client_AX], ERR_UNKNOWN_VM
	ret

	; Get a VmMsg struct
dmp70:	mov	cx, [VmMsgAlloc]
	mov	edi, [VmMsgOff]
	mov	eax, [ebp.Client_EBX]
dmp80:	xchg	[edi.Handle], eax
	cmp	eax, 0
	je	short dmp90
	xchg	[edi.Handle], eax
	add	edi, size VmMsg
	loop	dmp80
	mov	[ebp.Client_AX], ERR_MSG_FULL
	ret

dmp90:	test	[ebp.Client_EAX], FLAG_SEND_MSG	; send?
	jz	short dmp110
	xor	ecx, ecx			; Set up a semaphore
	VMMcall	Create_Semaphore
	jnc	short dmp100
	mov	[ebp.Client_AX], ERR_NO_SEMAPHORE
	ret

dmp100:	mov	[edi.SendSem], eax
	
dmp110:	mov	eax, [ebp.Client_EAX]		; save message
	mov	[edi.lParam1], eax
	mov	eax, [ebp.Client_EDX]
	mov	[edi.lParam2], eax
	mov	eax, [ebp.Client_ECX]
	mov	[edi.lWndMsg], eax
	mov	[edi.VmOff], esi

	; lets generate the call-back
	mov	eax, Low_Pri_Device_Boost
	push	ebx
	mov	ebx, [esi.VmHandle]
	mov	ecx, PEF_Wait_For_STI or PEF_Wait_Not_Crit
	mov	edx, edi
	mov	esi, OFFSET32 HandleCallBack
	VMMcall	Call_Priority_VM_Event
	pop	ebx

	mov	edx, [edi.Rtn]			; rtn regs & Client_regs
	test	[ebp.Client_EAX], FLAG_SEND_MSG	; send?
	jz	short dmp130

dmp120:	mov	eax, [edi.SendSem]
	mov	ecx, Block_Svc_Ints or Block_Enable_Ints
	VMMcall	Wait_Semaphore			; block until sent

	mov	eax, [edi.SendSem]
	VMMcall	Destroy_Semaphore		; destroy it
	mov	edx, [edi.Rtn]			; rtn regs & Client_regs
	mov	[edi.Handle], 0			; Mark VmMsg avail

dmp130:	mov	[ebp.Client_EDX], edx
	mov	eax, ERR_NONE
	mov	[ebp.Client_EAX], eax

	ret

LinkMsgProc  endp

; ENTRY:	EAX = SEG:OFF
;		EBX = VM handle
; EXIT:		EAX = offset32
V86ToPmPtr	proc

	Save	<edx>

	cmp	ebx, [SysVm]
	jne	short vtp20

	Save	<ecx>
	push	eax
	shr	eax, 16
	VMMcall	_SelectorMapFlat <[SysVm], EAX, 0>
	pop	edx

	cmp	eax, -1
	je	short vtp10

	and	edx, 0FFFFh
	add	eax, edx
	Restore	<ecx,edx>
	clc
	ret

vtp10:	Restore	<ecx,edx>
	stc
	ret

vtp20:	movzx	edx, ax
	shr	eax, 12
	and	eax, 0FFFF0h
	add	eax, edx
	add	eax, [ebx.CB_High_Linear]

	Restore	<edx>
	clc
	ret

V86ToPmPtr	endp


;*********************************
;	DOS calls
;*********************************

MsgGetVer  proc

	mov	[ebp.Client_EAX], 03A0h
	ret

MsgGetVer  endp

; ENTRY:	Client_EDX = pName
; EXIT:		Client_EAX = hVm
MsgRegister  proc

	mov	eax, ebx
	call	GetVmData

	mov	eax, [ebp.Client_EDX]
	call	V86ToPmPtr

	lea	edi, [esi].sProgName
	mov	esi, eax
	mov	ecx, 32 / 4
	rep	movsd
	mov	byte ptr [edi - 1], 0

	mov	[ebp.Client_EAX], ebx		; return handle
	ret

MsgRegister  endp

MsgUnregister  proc

	; zero out sProgName
	mov	eax, ebx
	call	GetVmData
	mov	[esi].sProgName, 0
	mov	[ebp.Client_EAX], ERR_NONE

	ret

MsgUnregister  endp

; ENTRY:	EDX = pName
; EXIT:		EAX = hVm
MsgQueryVm	proc

	mov	eax, [SysVm]
	call	GetVmData

	mov	eax, [ebp.Client_EDX]
	call	V86ToPmPtr
	jc	short mqv50
	mov	edi, eax

mqv10:	Save	<edi,esi>
	lea	esi, [esi].sProgName
	mov	ecx, 32

mqv20:	cmpsb
	jne	short mqv30
	cmp	byte ptr [esi], 0
	je	short mqv30
	loop	mqv20

mqv30:	Restore	<esi,edi>
	je	short mqv40

	cmp	[esi.LinkNext], 0
	je	short mqv50
	mov	esi, [esi.LinkNext]
	jmp	short mqv10

mqv40:	mov	eax, [esi.VmHandle]		; Return VM handle
	mov	[ebp.Client_EAX], eax
	ret

mqv50:	mov	[ebp.Client_EAX], 0		; error
	ret

MsgQueryVm	endp

; ENTRY:	AX = MSG_LAUNCH
;		CX = ShowCmd
;		EDX = pCmd
; EXIT:		AX = uErr
MsgLaunch  proc

	mov	eax, [ebp.Client_EDX]
	call	V86ToPmPtr
	mov	edi, eax

	mov	eax, ebx
	call	GetVmData
	mov	edx, [esi].VmLdt
	lea	esi, [esi].sExec
	xchg	esi, edi
	mov	ecx, 128 / 4
	rep	movsd

	mov	di, [ebp.Client_CX]
	Save	<ebx>
	SendPm	[SysVm], [SysWnd], MSG_DOS_EXEC, di, edx

	VMMcall	Release_Time_Slice
	VMMcall	Get_Execution_Focus
	VMMcall	Set_Execution_Focus
	Restore	<ebx>

	mov	[ebp.Client_EAX], edx
	ret

MsgLaunch  endp

; if free == next the buffer is empty
; if free == next-1 the buffer is full
; for wrapping, if next == arr && free == size-1 => buffer is full

;
; If to Windows - we go to Windows & post it.  If to DOS, we store it
; in our per/VM structure.
;
; ENTRY:	EBX = hVm (0 if to Windows)
;		CXh = hWnd
;		CX  = uMsg
;		DI  = wParam
;		EDX = lParam
; EXIT:		AX  = uErr
MsgPost  proc

	;BUGBUG - Windows stuff

	mov	eax, [ebp.Client_EBX]
	call	GetVm
	jc	short mp05
	cmp	eax, [SysVm]
	jne	short mp10

	PostPm	[SysVm], [ebp.Client_CX], <word ptr [ebp.Client_ECX+2]>, [ebp.Client_DI], [ebp.Client_EDX]
	mov	[ebp.Client_EAX], ERR_NONE
	ret

mp05:	mov	[ebp.Client_EAX], ERR_UNKNOWN_VM
	ret

mp10:	call	GetVmData			; ESI = VmData of dest VM

	; Do we have room in the message array???
	; NO if Write == Read-1 OR (Read == MsgArr AND Write == last element)
	mov	eax, size DosMsg
	mov	edi, [esi].MsgGet
	sub	edi, eax
	cmp	edi, [esi].MsgPut		; Write == Read-1?
	je	short mp90			; YES

	lea	edx, [esi].MsgArr
	cmp	[esi].MsgGet, edx		; Read == MsgArr?
	jne	short mp20			; NO
	mov	eax, [esi].MsgLast
	cmp	eax, [esi].MsgPut		; AND Write == last
	je	short mp90

	; OK we can store it
mp20:	mov	edi, [esi].MsgPut
	mov	ax, [ebp.Client_CX]
	mov	[edi].dWnd, ax
	mov	ax, word ptr [ebp.Client_ECX + 2]
	mov	[edi].dMsg, ax
	mov	ax, [ebp.Client_DI]
	mov	[edi].dwParam, ax
	mov	eax, [ebp.Client_EDX]
	mov	[edi].dlParam, eax

	; inc free, roll it if past end
	add	[esi].MsgPut, size DosMsg
	mov	eax, [esi].MsgLast
	cmp	[esi].MsgPut, eax
	jbe	short mp30
	lea	eax, [esi].MsgArr
	mov	[esi].MsgPut, eax

	; Signal read we have a message
mp30:	mov	eax, [esi.MsgSem]
	VMMcall	Signal_Semaphore

	; Boost the execution priority of the guy we call
	; so it gets the message ASAP.
;	mov	eax, Low_Pri_Device_Boost
;	VMMcall	Adjust_Exec_Priority

mp40:	mov	[ebp.Client_EAX], ERR_NONE
	ret

mp90:	mov	[ebp.Client_EAX], ERR_MSG_FULL
	ret

MsgPost  endp

; ENTRY:	AX = MSG_PEEK
;		EDX = pMsg
; EXIT:		AX = uErr
MsgPeek  proc

	mov	eax, ebx
	call	GetVmData			; ESI = VmData of VM

	; do we have one?
	mov	edi, [esi].MsgGet
	cmp	edi, [esi].MsgPut
	je	short mpk90

	; Lets fill it in
	mov	eax, [ebp].Client_EDX
	call	V86ToPmPtr
	mov	esi, edi
	mov	edi, eax
	mov	ecx, (size DosMsg) / 2
	rep	movsw

	mov	[ebp.Client_EAX], ERR_NONE
	ret

mpk90:	VMMcall	Release_Time_Slice
	mov	[ebp.Client_EAX], ERR_NO_MSG
	ret

MsgPeek  endp

MsgRead  proc

	mov	eax, ebx
	call	GetVmData			; ESI = VmData of VM

	; Lets block if there are no messages
	mov	eax, [esi.MsgSem]
	mov	ecx, Block_Svc_Ints or Block_Enable_Ints
	VMMcall	Wait_Semaphore

	; Lets fill it in
mr10:	Save	<esi>
	mov	eax, [ebp].Client_EDX
	call	V86ToPmPtr
	mov	esi, [esi].MsgGet
	mov	edi, eax
	mov	ecx, (size DosMsg) / 2
	rep	movsw
	Restore	<esi>

	; inc next, roll it if past end
	add	[esi].MsgGet, size DosMsg
	mov	eax, [esi].MsgLast
	cmp	[esi].MsgGet, eax
	jbe	short mr20
	lea	eax, [esi].MsgArr
	mov	[esi].MsgGet, eax

mr20:	mov	[ebp.Client_EAX], ERR_NONE
	ret

MsgRead  endp

MsgPrnOpen  proc

	mov	eax, ebx
	call	GetVmData

	; If job running - end it
	xor	eax, eax
	xchg	[esi.sPsp], al
	or	al, al
	jz	short mpo10
	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR_DNE, [esi.PrntNum], [esi.VmLdt]

mpo10:	mov	eax, [ebp.Client_EDX]
	call	V86ToPmPtr
	mov	edi, eax

	lea	esi, [esi].sExec
	xchg	esi, edi
	mov	ecx, 128 / 4
	rep	movsd

	mov	[ebp.Client_EAX], ERR_NONE
	ret

MsgPrnOpen  endp

MsgPrnWrite  proc

	mov	[ebp.Client_EAX], ERR_UNKNOWN_MSG
	mov	ax, ERR_UNKNOWN_MSG
	ret

MsgPrnWrite  endp

MsgPrnClose  proc

	mov	eax, ebx
	call	GetVmData
	mov	[esi].sExec, 0

	PostPm	[SysVm], [SysWnd], MSG_PRINT_CHAR_DNE, [esi.PrntNum], [esi.VmLdt]

	mov	[ebp.Client_EAX], ERR_NONE
	ret

MsgPrnClose  endp

; ENTRY:	AX = MSG_MEM_COPY
;		EBX = SrcVm
;		ECX = uNum
;		EDX = DestVm
;		EDI = pDest
;		ESI = pSrc
; EXIT:		AX = uErr
MsgMemCopy  proc

	Save	<ebx>

	; Get the params
	mov	eax, [ebp.Client_EBX]
	call	GetVm
	jc	short mmc50
	mov	ebx, eax

	mov	eax, [ebp.Client_ESI]
	call	V86ToPmPtr
	jc	short mmc40
	mov	esi, eax

	mov	eax, [ebp.Client_EDX]
	call	GetVm
	jc	short mmc50
	mov	ebx, eax

	mov	eax, [ebp.Client_EDI]
	call	V86ToPmPtr
	jc	short mmc40
	mov	edi, eax

	mov	ecx, [ebp.Client_ECX]
	Restore	<ebx>

	; Copy the dwords
	Save	<ecx>
	shr	ecx, 2
	rep	movsd
	Restore	<ecx>
	and	ecx, 03h
	jz	short mmc30
	rep	movsb

mmc30:	mov	[ebp.Client_EAX], ERR_NONE
	ret

mmc40:	Restore	<ebx>
	mov	[ebp.Client_EAX], ERR_BAD_SELECTOR
	ret

mmc50:	Restore	<ebx>
	mov	[ebp.Client_EAX], ERR_UNKNOWN_VM
	ret

MsgMemCopy  endp

; ENTRY:	AX = MSG_MEM_LDT
;		EBX = VmLdt
;		EDX = VmMem
;		EDI = pBuf
;		ECX = ulLimit
; EXIT:		AX = selector
MsgMemLdt  proc

	Save	<ebx>

	mov	eax, [ebp.Client_EDX]
	call	GetVm
	jc	short mml30
	mov	ebx, eax

	; Get flat address
	mov	eax, [ebp.Client_EDI]
	call	V86ToPmPtr
	jc	short mml30
	mov	esi, eax

	; Get the limit
	mov	edi, [ebp.Client_ECX]
	test	edi, 0FFF00000h
	jnz	short mml30

	mov	eax, [ebp.Client_EBX]
	call	GetVm
	jc	short mml30
	mov	ebx, eax

	; Create it
	VMMcall	_BuildDescriptorDWORDs <esi, edi, RW_Data_Type, D_GRAN_BYTE, 0>
	VMMcall	_Allocate_LDT_Selector <ebx, edx, eax, 1, 0>

	Restore	<ebx>
	mov	[ebp.Client_AX], ax
	ret

mml30:	Restore	<ebx>
	mov	[ebp.Client_EAX], 0
	ret

MsgMemLdt  endp

; ENTRY:	AX = MSG_MEM_FREE_LDT
;		EBX = VmMem
;		EDX = selector
; EXIT:		AX = uErr
MsgMemFreeLdt  proc

	Save	<ebx>

	mov	eax, [ebp.Client_EBX]
	call	GetVm
	jc	short mfl20
	mov	ebx, eax

	movzx	edx, word ptr [ebp.Client_EDX]
	VMMcall	_Free_LDT_Selector <ebx, edx, 0>

	Restore	<ebx>
	mov	[ebp.Client_EAX], 0
	ret

mfl20:	Restore	<ebx>
	mov	[ebp.Client_EAX], ERR_UNKNOWN_VM
	ret

MsgMemFreeLdt  endp

; ENTRY:	AX = MSG_MEM_GDT
;		EDX = VmMem
;		EDI = pBuf
;		ECX = ulLimit
; EXIT:		AX = selector
MsgMemGdt  proc

	; Get flat address
	Save	<ebx>
	mov	eax, [ebp.Client_EDX]
	call	GetVm
	jc	short mmg30
	mov	ebx, eax

	mov	eax, [ebp.Client_EDI]
	call	V86ToPmPtr
	Restore	<ebx>
	jc	short mmg20

	; Get the limit
	mov	edx, [ebp.Client_ECX]
	test	edx, 0FFF00000h
	jnz	short mmg20

	; Create it
	VMMcall	_BuildDescriptorDWORDs <eax, edx, RW_Data_Type, D_GRAN_BYTE, 0>
	VMMcall	_Allocate_GDT_Selector <edx, eax, 0>

	mov	[ebp.Client_AX], ax
	ret

mmg20:	mov	[ebp.Client_EAX], 0
	ret

mmg30:	Restore	<ebx>
	mov	[ebp.Client_EAX], ERR_UNKNOWN_VM
	ret

MsgMemGdt  endp

; ENTRY:	AX = MSG_MEM_FREE_GDT
;		EDX = selector
; EXIT:		AX = uErr
MsgMemFreeGdt  proc

	movzx	edx, word ptr [ebp.Client_EDX]
	VMMcall	_Free_GDT_Selector <edx, 0>

	mov	[ebp.Client_EAX], 0
	ret

MsgMemFreeGdt  endp

MsgSetTitle  proc

	mov	eax, ebx
	call	GetVmData			; esi = VmData

	mov	eax, [ebp.Client_EDX]
	call	V86ToPmPtr			; eax = [title]
	mov	edi, eax

	push	esi
	lea	esi, [esi].sTitle
	xchg	esi, edi
	mov	ecx, 79 / 4
	rep	movsd
	pop	esi

	PostPm	[SysVm], [SysWnd], MSG_DOS_TITLE, 0, [esi.VmLdt]

	mov	[ebp.Client_EAX], ERR_NONE
	ret

MsgSetTitle  endp


;*********************************
;	PM calls
;*********************************

_MsgRegister  proc

	mov	eax, ebx
	call	GetVmData

	mov	ax, [ebp.Client_CX]
	mov	[SysWnd], ax

	or	[SysFlags], EXEC_OFF or PRINT_OFF or TITLE_OFF
	and	[SysFlags], not IPC_OFF

	mov	eax, [ebp.Client_EDX]
	mov	[SysCallBack], eax

	mov	dword ptr [esi].sProgName, "-niW"
	mov	dword ptr [esi].sProgName + 4, "kniL"
	mov	[esi].sProgName + 8, 0

	mov	[ebp.Client_EAX], VER_NUM
	mov	[ebp.Client_EDX], ebx		; return handle
	ret

_MsgRegister  endp

_MsgUnregister  proc

	mov	eax, ebx
	call	GetVmData
	mov	[esi].sProgName, 0

	or	[SysFlags], IPC_OFF or EXEC_OFF or PRINT_OFF or TITLE_OFF
	mov	[SysCallBack], 0		; 0 it out

	mov	[ebp.Client_EAX], ERR_NONE
	ret

_MsgUnregister  endp


;*********************************
;	System calls
;*********************************

_MsgSendRtn  proc

	; Check edi (points to VmMsg, good handle)
	mov	edi, [ebp.Client_EDX]
	mov	ecx, [VmMsgOff]
	cmp	edi, ecx
	jb	short msr10

	mov	eax, size VmMsg
	mul	[VmMsgAlloc]
	add	eax, ecx
	cmp	edi, eax
	jae	short msr10
	cmp	ebx, [edi.Handle]
	jne	short msr10

	; Its ok - save the rtn value & turn semaphore off
	mov	eax, [ebp.Client_ECX]
	mov	[edi.Rtn], eax
	mov	eax, [edi.SendSem]
	VMMcall	Signal_Semaphore

msr10:	ret

_MsgSendRtn  endp

_MsgSetWinFile  proc

	push	ds
	xor	esi, esi
	lds	si, [ebp.Client_ECX]
	mov	edi, offset32 SysFile
	mov	ecx, 3
	rep	movsd
	pop	ds

	mov	edi, offset32 SysFile
	mov	al, 0
	mov	ecx, 12
	repne	scasb
	neg	ecx
	add	ecx, 12
	mov	[SysFileLen], cx

	ret

_MsgSetWinFile  endp

_MsgSetFlags  proc

	mov	ax, [ebp.Client_CX]
	and	ax, EXEC_OFF or PRINT_OFF or TITLE_OFF
	mov	cx, [SysFlags]
	and	cx, not (EXEC_OFF or PRINT_OFF or TITLE_OFF)
	or	ax, cx
	mov	[SysFlags], ax

	ret

_MsgSetFlags  endp

_MsgPrnBlkRtn  proc

	push	ds
	lds	si, [ebp.Client_EDX]
	mov	ax, [ebp.Client_CX]
	mov	[esi.iPrnErr], ax

	mov	eax, [esi.PrnSem]
	pop	ds

	VMMcall	Signal_Semaphore

pbr10:	ret

_MsgPrnBlkRtn  endp

_MsgSetIgnoreWin  proc

	push	ds
	xor	esi, esi
	lds	si, [ebp.Client_ECX]
	mov	edi, offset32 IgnoreStr
	mov	ecx, (160 / 4)
	rep	movsd
	pop	ds

	ret

_MsgSetIgnoreWin  endp

_MsgSetTimeOut  proc

	mov	ax, [ebp.Client_CX]
	mov	dx, 100
	mul	dx
	mov	[SysTimeOut], ax

	ret

_MsgSetTimeOut  endp

_MsgShellEvent  proc

	push	ebx
	mov	eax, [ebp.Client_ECX]
	mov	ebx, eax
	call	GetVmData
	mov	ecx, 6969h
	movzx	eax, word ptr [esi.VmLdt + 2]
	xor	esi, esi
	xor	edx, edx
	VxDcall	SHELL_Event
	pop	ebx
	ret

_MsgShellEvent  endp

; Pass VM in eax - return in eax.
; If eax is 0 -> switch to SysVm
; return CY if not a legit VM
GetVm  proc

	or	eax, eax
	jnz	short gv10
	mov	eax, [SysVm]

gv10:	Save	<ebx>
	mov	ebx, eax
	VMMcall	Validate_VM_Handle
	Restore	<ebx>

	ret

GetVm  endp

VxD_LOCKED_CODE_ENDS

	END

