

VER_NUM			EQU		0110h
; Also set in win_link.h


; Messages to Windows

; My ID is 295d, 127h => 
WIN_IPC_ID		EQU		24E0h


; Messages to Win-Link
MSG_WIN_IPC		EQU		678Ah

MSG_WIN_EXEC		EQU		6789h
MSG_PRINT_NEW		EQU		678Bh
MSG_PRINT_OFF		EQU		678Ch
MSG_PRINT_FILE		EQU		678Dh
MSG_PRINT_CHAR		EQU		678Eh
MSG_PRINT_FILE_BLK	EQU		678Fh
MSG_PRINT_FILE_DNE	EQU		6790h
MSG_PRINT_PSP		EQU		6791h
MSG_PRINT_CHAR_DNE	EQU		6792h
MSG_PRINT_CHAR_DESTROY	EQU		6793h
MSG_DOS_EXEC		EQU		6794h
MSG_DOS_TITLE		EQU		6795h

; Services in Win-IPC
MSG_GET_VER		EQU		0
MSG_REGISTER		EQU		1
MSG_UNREGISTER		EQU		2
MSG_QUERY_VM		EQU		3
MSG_LAUNCH		EQU		4
MSG_POST		EQU		5
MSG_PEEK		EQU		6
MSG_READ		EQU		7
MSG_PRN_OPEN		EQU		8
MSG_PRN_WRITE		EQU		9
MSG_PRN_CLOSE		EQU		10
MSG_MEM_COPY		EQU		11
MSG_MEM_LDT		EQU		12
MSG_MEM_FREE_LDT	EQU		13
MSG_MEM_GDT		EQU		14
MSG_MEM_FREE_GDT	EQU		15
MSG_SET_TITLE		EQU		16

MSG_DOS_MAX		EQU		16

; Services in Win-IPC for Win-Link ONLY
_MSG_REGISTER		EQU		17
_MSG_UNREGISTER		EQU		18
_MSG_SEND_RTN		EQU		19	; ALSO set in win_link.h
_MSG_SET_WIN_FILE	EQU		20
_MSG_SET_FLAGS		EQU		21
_MSG_PRN_BLK_RTN	EQU		22	; ALSO set in win_link.h
_MSG_SET_IGNORE_WIN	EQU		23
_MSG_SET_TIME_OUT	EQU		24
_MSG_SHELL_EVENT	EQU		25


; SysFlags
; also do in win_link.h
EXEC_OFF		EQU		0001h
PRINT_OFF		EQU		0002h
NO_IGNORE		EQU		0004h
MEM_OFF			EQU		0008h
IPC_OFF			EQU		0010h
TITLE_OFF		EQU		0020h

; VmData.wFlags
I24_ON			EQU		0040h
TITLE_SET		EQU		0080h


NUM_DATA_STRUC		EQU		40
NUM_MSG_STRUC		EQU		20
SIZE_PRNT_BLOCK		EQU		1022
SIZE_PRNT_BUF		EQU		3076


FLAG_SEND_MSG		EQU		00010000h
FLAG_HI_PRI		EQU		00020000h

; int 17h return codes
PRN_OK			EQU		90h
;PRN_BUSY		EQU		18h
PRN_BUSY		EQU		09h
PRN_ERR			EQU		09h


; errors from VXD

ERR_NONE		EQU		0
ERR_UNKNOWN_VM		EQU		1
ERR_UNKNOWN_ID		EQU		2
ERR_SEND_FAILED		EQU		3	; can't send - try again
ERR_MSG_FULL		EQU		4
ERR_VM_FULL		EQU		5
ERR_UNKNOWN_MSG		EQU		6
ERR_POST_FAILED		EQU		7	; post/send failed
ERR_UNKNOWN_ERR		EQU		8
ERR_NO_VXD		EQU		9
ERR_NO_SEMAPHORE	EQU		10
ERR_NO_WIN_APP		EQU		11
ERR_DUP_WIN_APP		EQU		12
ERR_WIN_TO_WIN		EQU		13
ERR_UNREGISTER_OTHER	EQU		14
ERR_NO_VM_MEMORY	EQU		15
ERR_NO_MSG		EQU		16
ERR_BAD_SELECTOR	EQU		17


; struc for holding DOS box messages
MAX_DOS_MSG		EQU		32
DosMsg	struc
	dWnd		dw	?
	dMsg		dw	?
	dwParam		dw	?
	dlParam		dd	?
DosMsg	ends

VmData	struc
	VmLdt		dd	0
	VmHandle	dd	0
	PrnSem		dd	0
	MsgSem		dd	0
	TimeHdl		dd	0
	LinkNext	dd	0
	LdtNext		dd	0
	pPsp		dd	0

	MsgGet		dd	0		; Next Message to read
	MsgPut		dd	0		; Next free spot
	MsgLast		dd	0		; Next == Free -> empty

	PrntNum		dw	0
	hDc		dw	0
	iPrnErr		dw	0
	iStr		dw	0
	hWnd		dw	0
	wFlags		dw	0
	BufCnt		dw	0

	PrntBuf		db	SIZE_PRNT_BUF dup (0)
	sXtra		db	0, 0
	MsgArr		db	((size DosMsg) * MAX_DOS_MSG) dup (?)

	sPsp		db	9 dup (0), 0
	sProgName	db	31 dup (' '), 0
	sTitle		db	80 dup (0)
	sExec		db	129 dup (0), 0
	sCmdLine	db	129 dup (0), 0
	sPrntStr	db	129 dup (0), 0
VmData	ends
.errnz ((size VmData) and 3)

; Win-IPC message
VmMsg	struc
	Handle		dd	0		; Vm Handle to send/post to
	lParam1		dd	?		; EAX
	lParam2		dd	?		; EDX
	lWndMsg		dd	?		; ECX
	VmOff		dd	?		; offset to VmData
	SendSem		dd	?		; Semaphore (if send)
	Rtn		dd	?		; Rtn value
VmMsg	ends
.errnz ((size VmMsg) and 3)

; Windows message
VXDMSG	struc
	mWnd		dw	?
	mMsg		dw	?
	mwParam		dw	?
	mFlags		dw	?
	mlParam		dd	?
	mEDI		dd	?
	InUse		dw	0
VXDMSG	ends


; EAX: uMsg = Message to post to Win-IPC
; ECX: lParam1 = first long param
; EDX: lParam2 = second long param
CallVxd MACRO	uMsg, lParam1, lParam2
local	a
	cmp	[WinIpcAddr], 0
	je	short a

	mov	ecx, lParam1
	mov	edx, lParam2
	mov	eax, uMsg
	xor	ebx, ebx

	call	dword ptr [WinIpcAddr]
a:
	ENDM


PostPm MACRO	lVm,hWnd,uMsg,wParam,lParam
	mov	eax, lVm
	mov	[ebp.Client_EBX], eax
	mov	ax, uMsg
	shl	eax, 16
	mov	ax, hWnd
	mov	[ebp.Client_ECX], eax
	mov	eax, 0
	mov	ax, wParam
	mov	[ebp.Client_EAX], eax
	mov	eax, lParam
	mov	[ebp.Client_EDX], eax
	call	LinkMsgProc
	ENDM

SendPm MACRO	lVm,hWnd,uMsg,wParam,lParam
	mov	eax, lVm
	mov	[ebp.Client_EBX], eax
	mov	ax, uMsg
	shl	eax, 16
	mov	ax, hWnd
	mov	[ebp.Client_ECX], eax
	mov	eax, FLAG_SEND_MSG
	mov	ax, wParam
	mov	[ebp.Client_EAX], eax
	mov	eax, lParam
	mov	[ebp.Client_EDX], eax
	call	LinkMsgProc
	ENDM


Save	MACRO	reg

	irp	r, <reg>
	push	r
	endm

	ENDM

Restore	MACRO	reg

	irp	r, <reg>
	pop	r
	endm

	ENDM
