

// Also set in win_ipc.inc, raw.rc, win_link.rc
#define			VER_MAJ								1
#define			VER_MIN								16

#define			VER_STR								"1.16"
#define			VER_NUM								((VER_MAJ << 8) | VER_MIN)


// some generic stuff

typedef  char           	FLAG;
#define  __minmax(a,b,c) 	((c)<(a) ? (a) : (c)>(b) ? (b) : (c))

#define  OFF(p)			((unsigned) (((long) (void far *) (p)) & 0xFFFFL))
#define  SEG(p)			((unsigned) (((long) ((void far *) (p))) >> 16))
#define  PTR(s,o)		((void far *)( ((long)(s)<<16) | ((long)(o)&0xFFFFL) ))



#define			WIN_IPC_ID						0x24E0


#define			IPC_TIMER_ID					0x9ACE


#define			MAX_VMS								40



#define			MSG_WIN_EXEC					0x6789
#define			MSG_WIN_IPC						0x678A
#define			MSG_PRINT_NEW					0x678B
#define			MSG_PRINT_OFF					0x678C
#define			MSG_PRINT_FILE				0x678D
#define			MSG_PRINT_CHAR				0x678E
#define			MSG_PRINT_FILE_BLK		0x678F
#define			MSG_PRINT_FILE_DNE		0x6790
#define			MSG_PRINT_PSP					0x6791
#define			MSG_PRINT_CHAR_DNE		0x6792
#define			MSG_PRINT_CHAR_DESTROY	0x6793
#define			MSG_DOS_EXEC					0x6794
#define			MSG_DOS_TITLE					0x6795
#define			MSG_EVENT_ON					0x6796
#define			MSG_EVENT_OFF					0x6797


// ALSO set in win_ipc.inc
#define			_MSG_SEND_RTN					19
#define			_MSG_PRN_BLK_RTN			22


// ALSO do in win_ipc.inc
#define			EXEC_OFF							0x01
#define			PRINT_OFF							0x02
#define			NO_IGNORE							0x04
#define			TITLE_OFF							0x20



#define			MNU_SAVE							200
#define			MNU_RESTORE						201
#define			MNU_ADD								202
#define			MNU_DELETE						203
#define			MNU_WIN_COM						204
#define			MNU_EXIT							205

#define			MNU_TIME_OUT					206

#define			MNU_HELP_INDEX				207
#define			MNU_HELP_EXEC					208
#define			MNU_HELP_PRINT				209
#define			MNU_HELP_OPTIONS			210
#define			MNU_HELP_GENERAL			211
#define			MNU_HELP							212
#define			MNU_ABOUT							213

#define			MNU_POP_ORIG					250
#define			MNU_POP_FILE					250
#define			MNU_POP_OPTN					251
#define			MNU_POP_HELP					252


#define			DLG_OK								1
#define			DLG_CANCEL						2
#define			DLG_RUN_WIN						99

#define			DLG_WIN_COM						100
#define			DLG_PRGM_MGR					101
#define			DLG_IGNORE						102
#define			DLG_PROMPT						103
#define			DLG_RUN								104

#define			DLG_EXEC_ON						105
#define			DLG_PRINT_ON					106
#define			DLG_TITLE_ON					107

#define			DLG_TIME_OUT					108

#define			DLG_EXEC_NAME					109

#define			DLG_NO_EXEC						110
#define			DLG_PRINT							111
#define			DLG_SDK								112

#define			DLG_HELP_CTRL					113

#define			DEMO_TIMER						128


#define			STR_ERR_TITLE					32
#define			STR_ERR_INST					33
#define			STR_ERR_386						34
#define			STR_ERR_ALLOC					35
#define			STR_ERR_IPC						36
#define			STR_ERR_VER						37
#define			STR_ERR_TIMER					38
#define			STR_ERR_NO_RAW				39
#define			STR_IGNORE_WIN				40
#define			STR_ERR_PRN_FILE			41
#define			STR_ERR_PRN_PSP				42
#define			STR_ERR_TIME_UP				43


#define			MAX_DOS_MSG						32

typedef struct S_DOSMSG
		{
		HWND		hWnd;
		UINT		hMsg;
		WORD		wParam;
		LONG		lParam;
		} DOSMSG;


// match in win_ipc.inc
typedef struct S_VMDATA
		{
		void _far		*VmLdt;
		long				VmHandle;
		long				PrnSem;
		long				MsgSem;
		long				TimeHdl;
		struct S_VMDATA _far	*LinkNext;
		struct S_VMDATA _far	*LdtNext;
		BYTE _far		*pPsp;

		DOSMSG _far	*MsgNext;
		DOSMSG _far	*MsgFree;
		DOSMSG _far	*MsgEnd;

		unsigned		PrntNum;
		HDC					hDc;
		int					iPrnErr;
		int					iStr;
		HWND				hWnd;
		unsigned		wFlags;
		unsigned		BufCnt;

		BYTE				PrntBuf[3076];
		BYTE				sXtra[2];
		DOSMSG			MsgArr[MAX_DOS_MSG];

		BYTE				sPsp[10];
		BYTE				sProgName[32];
		BYTE				sTitle[80];
		BYTE				sExec[130];
		BYTE				sCmdLine[130];
		BYTE				sPrntStr[130];
		} VMDATA;

typedef struct S_VXDMSG
			{
			HWND		hWnd;
			UINT		uMsg;
			WORD		wParam;
			WORD		wFlags;
			LONG		lParam;
			long		lEDI;
			WORD		InUse;
			} VXDMSG;


typedef struct S_LOADMOD
			{
			WORD		wEnvSeg;
			LPSTR		lpCmdLine;
			LPVOID	lpCmdShow;
			DWORD		dwRes;
			} LOADMOD;

typedef struct S_SENDDLG
			{
			LONG	lRtn;
			LONG	lParam;
			WORD	wParam;
			} SENDDLG;

typedef struct S_PRINTFILE
			{
			HDC		hDc;
			int		hFile;
			BYTE	*pBuf;
			int		iStr;
			int		iRtn;
			} PRINTFILE;


unsigned dRegisterWin (HWND hWnd);
void dUnRegisterWin (void);
void dSetWinFile (BYTE _far *psFile);
long dQueryVmId (long l);
void dPostMsg (unsigned,long,long);
void dSetFlags (unsigned uFlags);
void dSetIgnoreWin (BYTE _far *psFile);
void dSetTimeOut (unsigned iTimeOut);
void dShellEvent (long lVm);

